diff --git a/testsuite/hmac-test.c b/testsuite/hmac-test.c
index 0f14934..0356cf5 100644
--- a/testsuite/hmac-test.c
+++ b/testsuite/hmac-test.c
@@ -1,349 +1,435 @@
 #include "testutils.h"
 #include "hmac.h"
 
-/* KEY and MSG are supposed to expand to length, data */ 
-#define HMAC_TEST(alg, length, key, msg, mac) do {		\
-  hmac_##alg##_set_key(&alg, key);				\
-  hmac_##alg##_update(&alg, msg);				\
-  digest[length] = 17;						\
-  hmac_##alg##_digest(&alg, length, digest);			\
-  ASSERT(MEMEQ (length, digest, mac));				\
-  ASSERT(digest[length] == 17);					\
-} while (0)
+#define HEX_NONE 0
+#define HEX_KEY  1
+#define HEX_MSG   2
+
+enum {
+  alg_md5,
+  alg_ripemd160,
+  alg_sha1,
+  alg_sha224,
+  alg_sha256,
+  alg_sha384,
+  alg_sha512
+};
+
+static struct hmac_md5_ctx md5;
+static struct hmac_ripemd160_ctx ripemd160;
+static struct hmac_sha1_ctx sha1;
+static struct hmac_sha224_ctx sha224;
+static struct hmac_sha256_ctx sha256;
+static struct hmac_sha384_ctx sha384;
+static struct hmac_sha512_ctx sha512;
+
+/* sha512's digests are longest */
+static uint8_t digest[SHA512_DIGEST_SIZE+1];
+
+static void
+hmac_test(int alg,
+          unsigned digest_length,
+          int flags,
+          const uint8_t *key_hex,
+          const uint8_t *msg_hex,
+          const uint8_t *mac_hex)
+{
+  const uint8_t *key, *msg, *mac = decode_hex_dup(mac_hex);                                \
+  unsigned key_length, msg_length;
+
+  if (flags & HEX_KEY)
+    {
+      key_length = decode_hex_length(key_hex);
+      key = decode_hex_dup(key_hex);
+    }
+  else
+    {
+      key_length = strlen(key_hex);
+      key = key_hex;
+    }
+
+  if (flags & HEX_MSG)
+    {
+      msg_length = decode_hex_length(msg_hex);
+      msg = decode_hex_dup(msg_hex);
+    }
+  else
+    {
+      msg_length = strlen(msg_hex);
+      msg = msg_hex;
+    }
+
+  digest[digest_length] = 17;
+
+  switch (alg)
+    {
+    case alg_md5:
+        hmac_md5_set_key(&md5, key_length, key);
+        hmac_md5_update(&md5, msg_length, msg);
+        hmac_md5_digest(&md5, digest_length, digest);
+        break;
+    case alg_ripemd160:
+        hmac_ripemd160_set_key(&ripemd160, key_length, key);
+        hmac_ripemd160_update(&ripemd160, msg_length, msg);
+        hmac_ripemd160_digest(&ripemd160, digest_length, digest);
+        break;
+    case alg_sha1:
+        hmac_sha1_set_key(&sha1, key_length, key);
+        hmac_sha1_update(&sha1, msg_length, msg);
+        hmac_sha1_digest(&sha1, digest_length, digest);
+        break;
+    case alg_sha224:
+        hmac_sha224_set_key(&sha224, key_length, key);
+        hmac_sha224_update(&sha224, msg_length, msg);
+        hmac_sha224_digest(&sha224, digest_length, digest);
+        break;
+    case alg_sha256:
+        hmac_sha256_set_key(&sha256, key_length, key);
+        hmac_sha256_update(&sha256, msg_length, msg);
+        hmac_sha256_digest(&sha256, digest_length, digest);
+        break;
+    case alg_sha384:
+        hmac_sha384_set_key(&sha384, key_length, key);
+        hmac_sha384_update(&sha384, msg_length, msg);
+        hmac_sha384_digest(&sha384, digest_length, digest);
+        break;
+    case alg_sha512:
+        hmac_sha512_set_key(&sha512, key_length, key);
+        hmac_sha512_update(&sha512, msg_length, msg);
+        hmac_sha512_digest(&sha512, digest_length, digest);
+        break;
+    }
+
+  ASSERT(MEMEQ(digest_length, digest, mac));
+  ASSERT(digest[digest_length] == 17);
+
+  free((void *)mac);
+  if (flags & HEX_MSG)
+    free((void *)msg);
+  if (flags & HEX_KEY)
+    free((void *)key);
+}
 
 int
 test_main(void)
 {
-  struct hmac_md5_ctx md5;
-  struct hmac_sha1_ctx sha1;
-  struct hmac_ripemd160_ctx ripemd160;
-  struct hmac_sha224_ctx sha224;
-  struct hmac_sha256_ctx sha256;
-  struct hmac_sha384_ctx sha384;
-  struct hmac_sha512_ctx sha512;
-
-  /* sha512's digests are longest */
-  uint8_t digest[SHA512_DIGEST_SIZE+1];
-
-  memset(digest, 0, sizeof(digest));
-
   /* Test vectors for md5, from RFC-2202 */
 
   /* md5 - 1 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    HL("0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b"),
-	    LDATA("Hi There"),
-	    H("9294727a3638bb1c 13f48ef8158bfc9d"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_KEY,
+	    "0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b",
+	    "Hi There",
+	    "9294727a3638bb1c 13f48ef8158bfc9d");
 
 
   /* md5 - 2 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("Jefe"),
-	    LDATA("what do ya want for nothing?"),
-	    H("750c783e6ab0b503 eaa86e310a5db738"));	    
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "Jefe",
+	    "what do ya want for nothing?",
+	    "750c783e6ab0b503 eaa86e310a5db738");
 
   /* md5 - 3 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"),
-	    HL("dddddddddddddddd dddddddddddddddd"
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa",
+	    "dddddddddddddddd dddddddddddddddd"
 	       "dddddddddddddddd dddddddddddddddd"
 	       "dddddddddddddddd dddddddddddddddd"
-	       "dddd"),
-	    H("56be34521d144c88 dbb8c733f0e8b3f6"));
+	       "dddd",
+	    "56be34521d144c88 dbb8c733f0e8b3f6");
   
   /* md5 - 4 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    HL("0102030405060708 090a0b0c0d0e0f10" 
-	       "1112131415161718 19"),
-	    HL("cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "0102030405060708 090a0b0c0d0e0f10" 
+	       "1112131415161718 19",
+	    "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
-	       "cdcd"),
-	    H("697eaf0aca3a3aea 3a75164746ffaa79"));
+	       "cdcd",
+	    "697eaf0aca3a3aea 3a75164746ffaa79");
 
   /* md5 - 5 */
-  HMAC_TEST(md5, 12,
-	    HL("0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c"),
-	    LDATA("Test With Truncation"),
-	    H("56461ef2342edc00 f9bab995"));
+  hmac_test(alg_md5, 12, HEX_KEY,
+	    "0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c",
+	    "Test With Truncation",
+	    "56461ef2342edc00 f9bab995");
 
   /* md5 - 6 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
-	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"),
-	    LDATA("Test Using Larger Than Block-Size Key - Hash Key First"),
-	    H("6b1ab7fe4bd7bf8f 0b62e6ce61b9d0cd"));
+	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa",
+	    "Test Using Larger Than Block-Size Key - Hash Key First",
+	    "6b1ab7fe4bd7bf8f 0b62e6ce61b9d0cd");
 
   /* md5 - 7 */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
-	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"),
-	    LDATA("Test Using Larger Than Block-Size Key and Larger "
-		  "Than One Block-Size Data"),
-	    H("6f630fad67cda0ee 1fb1f562db3aa53e"));
+	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa",
+	    "Test Using Larger Than Block-Size Key and Larger "
+		  "Than One Block-Size Data",
+	    "6f630fad67cda0ee 1fb1f562db3aa53e");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA(""),
-	    H("e84db42a188813f30a15e611d64c7869"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "",
+	    "e84db42a188813f30a15e611d64c7869");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("a"),
-	    H("123662062e67c2aab371cc49db0df134"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "a",
+	    "123662062e67c2aab371cc49db0df134");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("38"),
-	    H("0a46cc10a49d4b7025c040c597bf5d76"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "38",
+	    "0a46cc10a49d4b7025c040c597bf5d76");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abc"),
-	    H("d1f4d89f0e8b2b6ed0623c99ec298310"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abc",
+	    "d1f4d89f0e8b2b6ed0623c99ec298310");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("message digest"),
-	    H("1627207b9bed5009a4f6e9ca8d2ca01e"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "message digest",
+	    "1627207b9bed5009a4f6e9ca8d2ca01e");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("922aae6ab3b3a29202e21ce5f916ae9a"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abcdefghijklmnopqrstuvwxyz",
+	    "922aae6ab3b3a29202e21ce5f916ae9a");
 
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"),
-	    H("ede9cb83679ba82d88fbeae865b3f8fc"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    "ede9cb83679ba82d88fbeae865b3f8fc");
 
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("12345678901234567890123456789012345678901234567890123456789012345678901234567890"),
-	    H("939dd45512ee3a594b6654f6b8de27f7"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "12345678901234567890123456789012345678901234567890123456789012345678901234567890",
+	    "939dd45512ee3a594b6654f6b8de27f7");
 
   /* Test vectors for ripemd160, from
      http://homes.esat.kuleuven.be/~bosselae/ripemd160.html */
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA(""),
-	    H("cf387677bfda8483e63b57e06c3b5ecd8b7fc055"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("a"),
-	    H("0d351d71b78e36dbb7391c810a0d2b6240ddbafc"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("abc"),
-	    H("f7ef288cb1bbcc6160d76507e0a3bbf712fb67d6"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("message digest"),
-	    H("f83662cc8d339c227e600fcd636c57d2571b1c34"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("843d1c4eb880ac8ac0c9c95696507957d0155ddb"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"),
-	    H("60f5ef198a2dd5745545c1f0c47aa3fb5776f881"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("00112233445566778899aabbccddeeff01234567"),
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"),
-	    H("e49c136a9e5627e0681b808a3b97e6a6e661ae79"));
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "",
+	    "cf387677bfda8483e63b57e06c3b5ecd8b7fc055");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "a",
+	    "0d351d71b78e36dbb7391c810a0d2b6240ddbafc");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "abc",
+	    "f7ef288cb1bbcc6160d76507e0a3bbf712fb67d6");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "message digest",
+	    "f83662cc8d339c227e600fcd636c57d2571b1c34");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "abcdefghijklmnopqrstuvwxyz",
+	    "843d1c4eb880ac8ac0c9c95696507957d0155ddb");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq",
+	    "60f5ef198a2dd5745545c1f0c47aa3fb5776f881");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "00112233445566778899aabbccddeeff01234567",
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    "e49c136a9e5627e0681b808a3b97e6a6e661ae79");
 
   /* Other key */
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA(""),
-	    H("fe69a66c7423eea9c8fa2eff8d9dafb4f17a62f5"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("a"),
-	    H("85743e899bc82dbfa36faaa7a25b7cfd372432cd"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("abc"),
-	    H("6e4afd501fa6b4a1823ca3b10bd9aa0ba97ba182"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("message digest"),
-	    H("2e066e624badb76a184c8f90fba053330e650e92"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("07e942aa4e3cd7c04dedc1d46e2e8cc4c741b3d9"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"),
-	    H("b6582318ddcfb67a53a67d676b8ad869aded629a"));
-
-  HMAC_TEST(ripemd160, RIPEMD160_DIGEST_SIZE,
-	    HL("0123456789abcdeffedcba987654321000112233"),
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"),
-	    H("f1be3ee877703140d34f97ea1ab3a07c141333e2"));
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "",
+	    "fe69a66c7423eea9c8fa2eff8d9dafb4f17a62f5");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "a",
+	    "85743e899bc82dbfa36faaa7a25b7cfd372432cd");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "abc",
+	    "6e4afd501fa6b4a1823ca3b10bd9aa0ba97ba182");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "message digest",
+	    "2e066e624badb76a184c8f90fba053330e650e92");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "abcdefghijklmnopqrstuvwxyz",
+	    "07e942aa4e3cd7c04dedc1d46e2e8cc4c741b3d9");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq",
+	    "b6582318ddcfb67a53a67d676b8ad869aded629a");
+
+  hmac_test(alg_ripemd160, RIPEMD160_DIGEST_SIZE, HEX_KEY,
+	    "0123456789abcdeffedcba987654321000112233",
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    "f1be3ee877703140d34f97ea1ab3a07c141333e2");
 
   /* Test vectors for sha1, from RFC-2202 */
 
   /* sha1 - 1 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    HL("0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b 0b0b0b0b"),
-	    LDATA("Hi There"),
-	    H("b617318655057264 e28bc0b6fb378c8e f146be00"));
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, HEX_KEY,
+	    "0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b 0b0b0b0b",
+	    "Hi There",
+	    "b617318655057264 e28bc0b6fb378c8e f146be00");
 
   /* sha1 - 2 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    LDATA("Jefe"),
-	    LDATA("what do ya want for nothing?"),
-	    H("effcdf6ae5eb2fa2 d27416d5f184df9c 259a7c79"));
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, HEX_NONE,
+	    "Jefe",
+	    "what do ya want for nothing?",
+	    "effcdf6ae5eb2fa2 d27416d5f184df9c 259a7c79");
 
   /* sha1 - 3 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa aaaaaaaa"),
-	    HL("dddddddddddddddd dddddddddddddddd"
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa aaaaaaaa",
+	    "dddddddddddddddd dddddddddddddddd"
 	       "dddddddddddddddd dddddddddddddddd"
 	       "dddddddddddddddd dddddddddddddddd"
-	       "dddd"),
-	    H("125d7342b9ac11cd 91a39af48aa17b4f 63f175d3"));
+	       "dddd",
+	    "125d7342b9ac11cd 91a39af48aa17b4f 63f175d3");
 
   /* sha1 - 4 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    HL("0102030405060708 090a0b0c0d0e0f10" 
-	       "1112131415161718 19"),
-	    HL("cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "0102030405060708 090a0b0c0d0e0f10" 
+	       "1112131415161718 19",
+	    "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcd cdcdcdcdcdcdcdcd"
-	       "cdcd"),
-	    H("4c9007f4026250c6 bc8414f9bf50c86c 2d7235da"));
+	       "cdcd",
+	    "4c9007f4026250c6 bc8414f9bf50c86c 2d7235da");
 
   /* sha1 - 5 */
-  HMAC_TEST(sha1, 12,
-	    HL("0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c 0c0c0c0c"),
-	    LDATA("Test With Truncation"),
-	    H("4c1a03424b55e07f e7f27be1"));
+  hmac_test(alg_sha1, 12, HEX_KEY,
+	    "0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c 0c0c0c0c",
+	    "Test With Truncation",
+	    "4c1a03424b55e07f e7f27be1");
 
   /* sha1 - 6 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
-	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"),
-	    LDATA("Test Using Larger Than Block-Size Key - Hash Key First"),
-	    H("aa4ae5e15272d00e 95705637ce8a3b55 ed402112"));
+	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa",
+	    "Test Using Larger Than Block-Size Key - Hash Key First",
+	    "aa4ae5e15272d00e 95705637ce8a3b55 ed402112");
 
   /* sha1 - 7 */
-  HMAC_TEST(sha1, SHA1_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
+  hmac_test(alg_sha1, SHA1_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"
-	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa"),
-	    LDATA("Test Using Larger Than Block-Size Key and Larger "
-		  "Than One Block-Size Data"),
-	    H("e8e99d0f45237d78 6d6bbaa7965c7808 bbff1a91"));
+	       "aaaaaaaaaaaaaaaa aaaaaaaaaaaaaaaa",
+	    "Test Using Larger Than Block-Size Key and Larger "
+		  "Than One Block-Size Data",
+	    "e8e99d0f45237d78 6d6bbaa7965c7808 bbff1a91");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA(""),
-	    H("e84db42a188813f30a15e611d64c7869"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "",
+	    "e84db42a188813f30a15e611d64c7869");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("a"),
-	    H("123662062e67c2aab371cc49db0df134"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "a",
+	    "123662062e67c2aab371cc49db0df134");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("38"),
-	    H("0a46cc10a49d4b7025c040c597bf5d76"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "38",
+	    "0a46cc10a49d4b7025c040c597bf5d76");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abc"),
-	    H("d1f4d89f0e8b2b6ed0623c99ec298310"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abc",
+	    "d1f4d89f0e8b2b6ed0623c99ec298310");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("message digest"),
-	    H("1627207b9bed5009a4f6e9ca8d2ca01e"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "message digest",
+	    "1627207b9bed5009a4f6e9ca8d2ca01e");
   
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("922aae6ab3b3a29202e21ce5f916ae9a"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abcdefghijklmnopqrstuvwxyz",
+	    "922aae6ab3b3a29202e21ce5f916ae9a");
 
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"),
-	    H("ede9cb83679ba82d88fbeae865b3f8fc"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    "ede9cb83679ba82d88fbeae865b3f8fc");
 
-  HMAC_TEST(md5, MD5_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("12345678901234567890123456789012345678901234567890123456789012345678901234567890"),
-	    H("939dd45512ee3a594b6654f6b8de27f7"));
+  hmac_test(alg_md5, MD5_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "12345678901234567890123456789012345678901234567890123456789012345678901234567890",
+	    "939dd45512ee3a594b6654f6b8de27f7");
 
   /* Test vectors for sha224, from RFC 4231 */
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    HL("0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
-	       "0b0b0b0b"),
-	    LDATA("Hi There"),
-	    H("896fb1128abbdf196832107cd49df33f"
-	      "47b4b1169912ba4f53684b22"));
-
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    LDATA("Jefe"),
-	    LDATA("what do ya want for nothing?"),
-	    H("a30e01098bc6dbbf45690f3a7e9e6d0f"
-	      "8bbea2a39e6148008fd05e44"));
-
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
-	       "aaaaaaaa"),
-	    HL("dddddddddddddddddddddddddddddddd"
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, HEX_KEY,
+	    "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
+	       "0b0b0b0b",
+	    "Hi There",
+	    "896fb1128abbdf196832107cd49df33f"
+	      "47b4b1169912ba4f53684b22");
+
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, HEX_NONE,
+	    "Jefe",
+	    "what do ya want for nothing?",
+	    "a30e01098bc6dbbf45690f3a7e9e6d0f"
+	      "8bbea2a39e6148008fd05e44");
+
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
+	       "aaaaaaaa",
+	    "dddddddddddddddddddddddddddddddd"
 	       "dddddddddddddddddddddddddddddddd"
 	       "dddddddddddddddddddddddddddddddd"
-	       "dddd"),
-	    H("7fb3cb3588c6c1f6ffa9694d7d6ad264"
-	      "9365b0c1f65d69d1ec8333ea"));
-
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    HL("0102030405060708090a0b0c0d0e0f10"
-	       "111213141516171819"),
-	    HL("cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd"
+	       "dddd",
+	    "7fb3cb3588c6c1f6ffa9694d7d6ad264"
+	      "9365b0c1f65d69d1ec8333ea");
+
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "0102030405060708090a0b0c0d0e0f10"
+	       "111213141516171819",
+	    "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd"
 	       "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd"
-	       "cdcd"),
-	    H("6c11506874013cac6a2abc1bb382627c"
-	      "ec6a90d86efc012de7afec5a"));
+	       "cdcd",
+	    "6c11506874013cac6a2abc1bb382627c"
+	      "ec6a90d86efc012de7afec5a");
 
-  HMAC_TEST(sha224, 16,
-	    HL("0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c 0c0c0c0c"),
-	    LDATA("Test With Truncation"),
-	    H("0e2aea68a90c8d37c988bcdb9fca6fa8"));
+  hmac_test(alg_sha224, 16, HEX_KEY,
+	    "0c0c0c0c0c0c0c0c 0c0c0c0c0c0c0c0c 0c0c0c0c",
+	    "Test With Truncation",
+	    "0e2aea68a90c8d37c988bcdb9fca6fa8");
 
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
@@ -351,13 +437,13 @@ test_main(void)
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
-	       "aaaaaa"),
-	    LDATA("Test Using Larger Than Block-Size Key - Hash Key First"),
-	    H("95e9a0db962095adaebe9b2d6f0dbce2"
-	      "d499f112f2d2b7273fa6870e"));
+	       "aaaaaa",
+	    "Test Using Larger Than Block-Size Key - Hash Key First",
+	    "95e9a0db962095adaebe9b2d6f0dbce2"
+	      "d499f112f2d2b7273fa6870e");
 
-  HMAC_TEST(sha224, SHA224_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
+  hmac_test(alg_sha224, SHA224_DIGEST_SIZE, HEX_KEY,
+	    "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
